"use strict";
const React = require("react");
const item_1 = require('./item');
const indicator_1 = require('./indicator');
exports.Carousel = React.createClass({
    getDefaultProps: function () {
        return {
            items: [],
            autoplayInterval: 2500,
            style: {},
        };
    },
    getInitialState: function () {
        return {
            items: this.props.items,
            indicators: [],
            activeIndex: 0,
            intervalId: undefined,
        };
    },
    calculatePreviousActiveIndex: function (currentActiveIndex) {
        let itemsCount = this.props.items.length;
        let previousActiveIndex = currentActiveIndex - 1;
        previousActiveIndex = previousActiveIndex < 0 ?
            itemsCount + previousActiveIndex :
            previousActiveIndex;
        let index = previousActiveIndex % itemsCount;
        // 转换为整数返回
        return parseInt(index);
    },
    calculateNextActiveIndex: function (currentActiveIndex) {
        let nextActiveIndex = currentActiveIndex + 1;
        let itemsCount = this.props.items.length;
        let index = nextActiveIndex % itemsCount;
        return parseInt(index);
    },
    componentDidMount: function () {
        let activeIndex = this.state.activeIndex;
        let itemsCount = this.state.items.length;
        let intervalId = setInterval(() => {
            activeIndex = this.calculateNextActiveIndex(activeIndex);
            this.setState({ activeIndex });
        }, this.props.autoplayInterval);
        this.setState({ intervalId });
    },
    render: function () {
        let state = this.state;
        return (React.createElement("div", {className: "carousel slide", "data-ride": "carousel"}, 
            React.createElement("ol", {className: "carousel-indicators"}, this.state.items.map((i, k) => {
                return React.createElement(indicator_1.default, {key: k, active: state.activeIndex == k, onClick: () => {
                    this.setState({ activeIndex: k });
                }});
            })), 
            React.createElement("div", {className: "carousel-inner", style: this.props.style}, this.state.items.map((i, k) => {
                return React.createElement(item_1.default, {key: k, caption: i.caption, imgAlt: i.imgAlt, imgSrc: i.imgSrc, href: i.href, active: state.activeIndex == k});
            })), 
            React.createElement("a", {className: "left carousel-control", "data-slide": "prev", onClick: (e) => {
                e.preventDefault();
                let activeIndex = this.calculatePreviousActiveIndex(this.state.activeIndex);
                this.setState({ activeIndex });
                return false;
            }}, 
                React.createElement("span", {className: "icon-prev", "aria-hidden": "true"}), 
                React.createElement("span", {className: "sr-only"}, "Previous")), 
            React.createElement("a", {className: "right carousel-control", "data-slide": "next", onClick: (e) => {
                e.preventDefault();
                let activeIndex = this.calculateNextActiveIndex(this.state.activeIndex);
                this.setState({ activeIndex });
                return false;
            }}, 
                React.createElement("span", {className: "icon-next", "aria-hidden": "true"}), 
                React.createElement("span", {className: "sr-only"}, "Next"))));
    },
});
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = exports.Carousel;
//# sourceMappingURL=index.js.map