"use strict";
const React = require('react');
const calculate_pagination_info_1 = require('./utils/calculate-pagination-info');
class Pagination extends React.Component {
    /**
     * 生成onClick事件处理函数的高阶函数
     */
    _genOnClick(e, i) {
        e.preventDefault();
        const onChange = this.props.onChange;
        return (e) => {
            onChange(i);
            return false;
        };
    }
    ;
    render() {
        let _info = calculate_pagination_info_1.default(this.props.count, this.props.size, this.props.current, this.props.semiBandWidth);
        // 生成一个数组，范围是[firstDigit~lastDigit]
        let array = Array.from(Array(_info.lastDigit - _info.firstDigit + 1), (d, k) => {
            return k + _info.firstDigit;
        });
        return (React.createElement("nav", null, 
            React.createElement("ul", {className: "pagination"}, 
                React.createElement("li", null, 
                    React.createElement("a", {href: "#", onClick: (e) => {
                        this._genOnClick(e, _info.firstDigit)(e);
                    }}, 
                        React.createElement("span", null, "« ")
                    )
                ), 
                array.map(i => {
                    return React.createElement("li", {key: i, onClick: (e) => this._genOnClick(e, i)(e)}, 
                        React.createElement("a", {href: "" + { i }}, i)
                    );
                }), 
                React.createElement("li", null, 
                    React.createElement("a", {href: "#", onClick: (e) => this._genOnClick(e, _info.lastDigit)(e)}, 
                        React.createElement("span", null, "» ")
                    )
                ))
        ));
    }
}
Pagination.defaultProps = {
    /**
     * 总的记录数目
     */
    count: 50,
    /**
     * 每页显示的记录数目
     */
    size: 10,
    /**
     * 当前第几页
     */
    current: 1,
    /**
     * 指的是从当前页码到显示的最大页码或最小页面的距离
     * 比如，当前页码是3，如果semiBandWidth=5,则lastDigit=8
     */
    semiBandWidth: 5,
    /**
     * 当页码改变时触发
     */
    onChange: (page) => { },
};
exports.Pagination = Pagination;
;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Pagination;
//# sourceMappingURL=index.js.map